unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls,
  grafika;

type
  TForm1 = class(TForm)
    Image1: TImage;
    BitBtn1: TBitBtn;
    Log: TMemo;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    txtRotateBy: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

procedure main;

implementation

{$R *.DFM}

const zero_x = 150;
const zero_y = 150;

var xlatem: TMatrix;
var f:textfile;



var shape: TShape;
    edge: TEdge;
    face: TFace;
var pm,pn:TPointMatrix;

var pt:TPoint;
    pth:TPointH;
    xpth:TPointH;

//-------------------------------- methods
procedure TForm1.FormCreate(Sender: TObject);
begin
  init(Image1.Canvas);
end;

{----------------------------------------------------------------------}
procedure println(msg:String);
begin
  Form1.Log.Lines.Add(msg);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
  var i,j:integer;
begin
  AssignFile(f, 'kocka.dat');
  Reset(f);

  readln(f, points.pointcount);
  for i:=1 to points.pointcount do begin
    for j:=1 to 3 do begin
      read(f, points.points[i, j]);
    end;
    points.points[i, 4] := 1;
    readln(f);
  end;

  readln(f);
  readln(f, edges.edgecount);
  for i:=1 to edges.edgecount do begin
    for j:=1 to 2 do begin
      read(f, edge[j]);
    end;
    edges.edges[i]:=edge;
    readln(f);
  end;

  readln(f);
  readln(f, shape.facecount);
  for i:=1 to shape.facecount do begin
    read(f, face.vcount);
    for j:=1 to face.vcount do begin
      read(f, face.vertices[j]);
    end;
    shape.faces[i]:=face;
    readln(f);
  end;

  CloseFile(f);
  //main;
end;

procedure main;
begin
  //usecka_b(20, 20, 35, 14, 5);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var i:integer;
      ptm: TPointMatrix;
      x1, y1:integer;
      x2, y2:integer;      
      edge: TEdge;
begin
  mem.Rectangle(0, 0, 500, 500);
  Log.Clear;

  if key in [VK_RIGHT, VK_LEFT, VK_UP, VK_DOWN, VK_ADD, VK_SUBTRACT,
  VK_PRIOR, VK_NEXT, VK_HOME, VK_END, VK_INSERT, VK_DELETE, Ord('C')] then begin
    if key=Ord('C') then begin
      mem.Rectangle(0, 0, 500, 500);
      Exit;
    end;

    for i:=1 to points.pointcount do begin
      PointMatrixToPointH(points.points[i], pth);

      if key=VK_RIGHT then begin
        translatePointH(pth, 30, 0, 0, xpth);
      end;
      if key=VK_LEFT then begin
        translatePointH(pth, -30, 0, 0, xpth);
      end;
      if key=VK_UP then begin
        translatePointH(pth, 0, -30, 0, xpth);
      end;
      if key=VK_DOWN then begin
        translatePointH(pth, 0, 30, 0, xpth);
      end;

      if key=VK_ADD then begin
        scalePointH(pth, 1.5, 1.5, 1.5, xpth);
      end;

      if key=VK_SUBTRACT then begin
        scalePointH(pth, 0.75, 0.75, 0.75, xpth);
      end;


      if key=VK_PRIOR then begin
        rotatePointHZ(pth, StrToInt(txtRotateBy.Text), xpth);
      end;

      if key=VK_NEXT then begin
        rotatePointHZ(pth, -StrToInt(txtRotateBy.Text), xpth);
      end;

      if key=VK_HOME then begin
        rotatePointHY(pth, StrToInt(txtRotateBy.Text), xpth);
      end;

      if key=VK_END then begin
        rotatePointHY(pth, -StrToInt(txtRotateBy.Text), xpth);
      end;

      if key=VK_INSERT then begin
        rotatePointHX(pth, StrToInt(txtRotateBy.Text), xpth);
      end;

      if key=VK_DELETE then begin
        rotatePointHX(pth, -StrToInt(txtRotateBy.Text), xpth);
      end;

      {
      if key=VK_HOME then begin
        rotatePointHEx(pth, StrToInt(txtRotateBy.Text), Round(shape[1].x), Round(shape[1].y), xpth);
      end;

      if key=VK_END then begin
        rotatePointHEx(pth, -StrToInt(txtRotateBy.Text), Round(shape[1].x), Round(shape[1].y), xpth);
      end;
      }

      pth:=xpth;
      bod_pc(zero_x + Round(pth.x), zero_y + Round(pth.y), 123);

      PointHToPointMatrix(pth, ptm);
      points.points[i]:=ptm;

      println(IntToStr(i) + '>' + FloatToStr(points.points[i,1]) + ' ' + FloatToStr(points.points[i, 2]) + ' ' + FloatToStr(points.points[i, 3]) + ' | ' + FloatToStr(points.points[i, 4]) + ' ');
    end;
    {
    for i:=1 to points.pointcount do begin
      usecka_b(zero_x + Round(points.points[i, 1]), zero_y + Round(points.points[i, 2]), zero_x + Round(points.points[(i+1) mod 4, 1]), zero_y + Round(points.points[(i+1) mod 4, 2]), 1);
    end;
    }
    for i:=1 to edges.edgecount do begin
      edge:=edges.edges[i];
      x1 := Round(points.points[edge[1], 1]);
      y1 := Round(points.points[edge[1], 2]);
      x2 := Round(points.points[edge[2], 1]);
      y2 := Round(points.points[edge[2], 2]);
      usecka_b(zero_x + x1, zero_y + y1, zero_x + x2, zero_y + y2, 1);
    end;

    for i:=1 to shape.facecount do begin
      face:=shape.faces[i];
      fillFace(face, Image1.Canvas, 1);
    end;
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  usecka_b(zero_x, 0, zero_x, Image1.Height, 5);
  usecka_b(0, zero_y, Image1.Width, zero_y, 5);  
end;

end.

