unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls,
  grafika;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Log: TMemo;
    grpOptions: TGroupBox;
    chkWireframe: TCheckBox;
    txtRotateBy: TEdit;
    lblRotateBy: TLabel;
    Label1: TLabel;
    txtMoveBy: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    cmdGo: TBitBtn;
    Label4: TLabel;
    txtFileName: TEdit;
    grpControls: TGroupBox;
    cmdLeft: TSpeedButton;
    cmdRight: TSpeedButton;
    cmdUp: TSpeedButton;
    cmdDown: TSpeedButton;
    cmdRotZL: TSpeedButton;
    cmdRotZR: TSpeedButton;
    cmdRotXL: TSpeedButton;
    cmdRotXR: TSpeedButton;
    cmdRotYR: TSpeedButton;
    cmdRotYL: TSpeedButton;
    Label5: TLabel;
    chkUseGDIFill: TCheckBox;
    chkDebugFill: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure cmdGoClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure cmdLeftClick(Sender: TObject);
    procedure cmdRightClick(Sender: TObject);
    procedure cmdUpClick(Sender: TObject);
    procedure cmdDownClick(Sender: TObject);
    procedure cmdRotZLClick(Sender: TObject);
    procedure cmdRotZRClick(Sender: TObject);
    procedure cmdRotXLClick(Sender: TObject);
    procedure cmdRotXRClick(Sender: TObject);
    procedure cmdRotYLClick(Sender: TObject);
    procedure cmdRotYRClick(Sender: TObject);
    procedure chkDebugFillClick(Sender: TObject);
    procedure chkUseGDIFillClick(Sender: TObject);
    procedure chkWireframeClick(Sender: TObject);
    procedure cmdGoMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

procedure main;

implementation

{$R *.DFM}

const zero_x = 150;
const zero_y = 150;

var xlatem: TMatrix;
var f:textfile;



var shape: TShape;
    edge: TEdge;
    face: TFace;
var pm,pn:TPointMatrix;
    bodv: TPointMatrix;

var pt:TPoint;
    pth:TPointH;
    xpth:TPointH;

//-------------------------------- methods
procedure TForm1.FormCreate(Sender: TObject);
begin
  init(Image1.Canvas);
  grafika.useGDIFill:=True;
end;

{----------------------------------------------------------------------}

procedure DrawNumbers;
  var i:integer;
begin
  for i:=1 to points.pointcount do begin
    Form1.Image1.Canvas.Font.Color:=clRed;
    Form1.Image1.Canvas.TextOut(zero_x + Round(points.points[i,1]), zero_y + Round(points.points[i,2]), IntToStr(i));
    Form1.Image1.Canvas.Font.Color:=clBlack;    
  end;
end;

procedure DrawVerticesIDs(face: TFace);
  var i:integer;
      edge: TEdge;
      prevfgcolor:TColor;
      prevbrushstyle:TBrushStyle;
begin
  for i:=1 to face.ecount do begin
    edge := face.edges[i];
    prevfgcolor:=Form1.Image1.Canvas.Font.Color;
    prevbrushstyle:=Form1.Image1.Canvas.Brush.Style;
    Form1.Image1.Canvas.Brush.Style := bsClear;
    Form1.Image1.Canvas.Font.Color:=clRed;
    Form1.Image1.Canvas.TextOut(zero_x + Round(points.points[edge[1]][1]), zero_y + Round(points.points[edge[1]][2]), IntToStr(i));
    Form1.Image1.Canvas.TextOut(zero_x + Round(points.points[edge[2]][1]), zero_y + Round(points.points[edge[2]][2]), IntToStr(i));
    Form1.Image1.Canvas.Font.Color:=prevfgcolor;
    Form1.Image1.Canvas.Brush.Style := prevbrushstyle;
  end;
end;

procedure println(msg:String);
begin
  Form1.Log.Lines.Add(msg);
end;

procedure TForm1.cmdGoClick(Sender: TObject);
  var i,j,k:integer;
      nv: TVector;
      u,v,w:TVector;
begin
  AssignFile(f, txtFileName.Text);
  Reset(f);

  readln(f, points.pointcount);
  for i:=1 to points.pointcount do begin
    for j:=1 to 3 do begin
      read(f, points.points[i, j]);
    end;
    points.points[i, 4] := 1;
    readln(f);
  end;

  readln(f);
  readln(f, edges.edgecount);
  for i:=1 to edges.edgecount do begin
    for j:=1 to 2 do begin
      read(f, edge[j]);
    end;
    edges.edges[i]:=edge;
    readln(f);
  end;

  readln(f);
  //nacitaj pocet stien
  readln(f, shape.facecount);
  for i:=1 to shape.facecount do begin
    //nacitaj pocet hran pre aktualnu stenu
    read(f, face.ecount);

    for j:=1 to face.ecount do begin
      read(f, k);
      face.edges[j] := edges.edges[k];
    end;
    shape.faces[i]:=face;
    readln(f);
  end;

  readln(f);
  for i:=1 to shape.facecount do begin
    for j:=1 to 3 do begin
      read(f, nv[j]);
    end;
    shape.faces[i].nvector2:=nv;
    readln(f);
  end;

  for i:=1 to shape.facecount do begin
    face:=shape.faces[i];
    getVector(points.points[face.edges[1][1]], points.points[face.edges[1][2]], u);
    getVector(points.points[face.edges[2][1]], points.points[face.edges[2][2]], v);
    VectorCrossProduct(u,v,w);
    shape.faces[i].nvector:=w;
  end;

  readln(f);
  for j:=1 to 3 do begin
    read(f, bodv[j]);
  end;
  bodv[4]:=1;
  readln(f);

  CloseFile(f);
  //main;
end;

procedure main;
begin
  //usecka_b(20, 20, 35, 14, 5);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var i,j:integer;
      ptm: TPointMatrix;
      x1, y1:integer;
      x2, y2:integer;
      edge: TEdge;
      angle: real;
      ptv: TPointH;
      xptv: TPointH;
      bodvh: TPointH;
      xbodvh: TPointH;
      nv:TVector;
      color: TColor;
begin
  Log.Clear;
  mem.Rectangle(0, 0, Image1.Width-1, Image1.Height-1);

  if key in [VK_RIGHT, VK_LEFT, VK_UP, VK_DOWN, VK_ADD, VK_SUBTRACT,
  VK_PRIOR, VK_NEXT, VK_HOME, VK_END, VK_INSERT, VK_DELETE, Ord('C'), VK_F5] then begin
    if key=Ord('C') then begin
      mem.Rectangle(0, 0, Image1.Width-1, Image1.Height-1);
      Exit;
    end;

    if key<>VK_F5 then begin
      for i:=1 to points.pointcount do begin
        PointMatrixToPointH(points.points[i], pth);
        PointMatrixToPointH(bodv, bodvh);

        if key=VK_RIGHT then begin
          translatePointH(pth, StrToInt(txtMoveBy.Text), 0, 0, xpth);
          if i=1 then begin
            translatePointH(bodvh, StrToInt(txtMoveBy.Text), 0, 0, xbodvh);
            PointHToPointMatrix(xbodvh, bodv);
          end;
          {
          for j:=1 to shape.facecount do begin
            VectorToPointH(shape.faces[j].nvector, ptv);
            translatePointH(ptv, 30, 0, 0, xptv);
            PointHToVector(xptv, shape.faces[j].nvector);
          end;
          }
        end;
        if key=VK_LEFT then begin
          translatePointH(pth, -StrToInt(txtMoveBy.Text), 0, 0, xpth);
          if i=1 then begin
            translatePointH(bodvh, -StrToInt(txtMoveBy.Text), 0, 0, xbodvh);
            PointHToPointMatrix(xbodvh, bodv);
          end;

          {
          for j:=1 to shape.facecount do begin
            VectorToPointH(shape.faces[j].nvector, ptv);
            translatePointH(ptv, -30, 0, 0, xptv);
            PointHToVector(xptv, shape.faces[j].nvector);
          end;
          }
        end;
        if key=VK_UP then begin
          translatePointH(pth, 0, -StrToInt(txtMoveBy.Text), 0, xpth);
          if i=1 then begin
            translatePointH(bodvh, 0, -StrToInt(txtMoveBy.Text), 0, xbodvh);
            PointHToPointMatrix(xbodvh, bodv);
          end;

          {
          for j:=1 to shape.facecount do begin
            VectorToPointH(shape.faces[j].nvector, ptv);
            translatePointH(ptv, 0, -30, 0, xptv);
            PointHToVector(xptv, shape.faces[j].nvector);
          end;
          }
        end;
        if key=VK_DOWN then begin
          translatePointH(pth, 0, StrToInt(txtMoveBy.Text), 0, xpth);
          if i=1 then begin
            translatePointH(bodvh, 0, StrToInt(txtMoveBy.Text), 0, xbodvh);
            PointHToPointMatrix(xbodvh, bodv);
          end;

          {
          for j:=1 to shape.facecount do begin
            VectorToPointH(shape.faces[j].nvector, ptv);
            translatePointH(ptv, 0, 30, 0, xptv);
            PointHToVector(xptv, shape.faces[j].nvector);
          end;
          }
        end;

        if key=VK_ADD then begin
          scalePointH(pth, 1.5, 1.5, 1.5, xpth);
        end;

        if key=VK_SUBTRACT then begin
          scalePointH(pth, 0.75, 0.75, 0.75, xpth);
        end;


        if key=VK_PRIOR then begin
          rotatePointHZ(pth, StrToInt(txtRotateBy.Text), xpth);
          if i=1 then begin
            for j:=1 to shape.facecount do begin
              VectorToPointH(shape.faces[j].nvector, ptv);
              rotatePointHZ(ptv, StrToInt(txtRotateBy.Text), xptv);
              PointHToVector(xptv, shape.faces[j].nvector);
            end;

            rotatePointHZ(bodvh, StrToInt(txtRotateBy.Text), xbodvh);
            PointHToPointMatrix(xbodvh, bodv);
          end;
        end;

        if key=VK_NEXT then begin
          rotatePointHZ(pth, -StrToInt(txtRotateBy.Text), xpth);
          if i=1 then begin
            for j:=1 to shape.facecount do begin
              VectorToPointH(shape.faces[j].nvector, ptv);
              rotatePointHZ(ptv, -StrToInt(txtRotateBy.Text), xptv);
              PointHToVector(xptv, shape.faces[j].nvector);
            end;

            rotatePointHZ(bodvh, -StrToInt(txtRotateBy.Text), xbodvh);
            PointHToPointMatrix(xbodvh, bodv);
          end;
        end;

        if key=VK_HOME then begin
          rotatePointHY(pth, StrToInt(txtRotateBy.Text), xpth);
          if i=1 then begin
            for j:=1 to shape.facecount do begin
              VectorToPointH(shape.faces[j].nvector, ptv);
              rotatePointHY(ptv, StrToInt(txtRotateBy.Text), xptv);
              PointHToVector(xptv, shape.faces[j].nvector);
            end;

            rotatePointHY(bodvh, StrToInt(txtRotateBy.Text), xbodvh);
            PointHToPointMatrix(xbodvh, bodv);
          end;

        end;

        if key=VK_END then begin
          rotatePointHY(pth, -StrToInt(txtRotateBy.Text), xpth);
          if i=1 then begin
            for j:=1 to shape.facecount do begin
              VectorToPointH(shape.faces[j].nvector, ptv);
              rotatePointHY(ptv, -StrToInt(txtRotateBy.Text), xptv);
              PointHToVector(xptv, shape.faces[j].nvector);
            end;

            rotatePointHY(bodvh, -StrToInt(txtRotateBy.Text), xbodvh);
            PointHToPointMatrix(xbodvh, bodv);
          end;
        end;

        if key=VK_INSERT then begin
          rotatePointHX(pth, StrToInt(txtRotateBy.Text), xpth);
          if i=1 then begin
            for j:=1 to shape.facecount do begin
              VectorToPointH(shape.faces[j].nvector, ptv);
              rotatePointHX(ptv, StrToInt(txtRotateBy.Text), xptv);
              PointHToVector(xptv, shape.faces[j].nvector);
            end;

            rotatePointHX(bodvh, StrToInt(txtRotateBy.Text), xbodvh);
            PointHToPointMatrix(xbodvh, bodv);
          end;
        end;

        if key=VK_DELETE then begin
          rotatePointHX(pth, -StrToInt(txtRotateBy.Text), xpth);

          if i=1 then begin
            for j:=1 to shape.facecount do begin
              VectorToPointH(shape.faces[j].nvector, ptv);
              rotatePointHX(ptv, -StrToInt(txtRotateBy.Text), xptv);
              PointHToVector(xptv, shape.faces[j].nvector);
            end;

            rotatePointHX(bodvh, -StrToInt(txtRotateBy.Text), xbodvh);
            PointHToPointMatrix(xbodvh, bodv);
          end;
        end;

        {
        if key=VK_HOME then begin
          rotatePointHEx(pth, StrToInt(txtRotateBy.Text), Round(shape[1].x), Round(shape[1].y), xpth);
        end;

        if key=VK_END then begin
          rotatePointHEx(pth, -StrToInt(txtRotateBy.Text), Round(shape[1].x), Round(shape[1].y), xpth);
        end;
        }

        pth:=xpth;
        bod_pc(zero_x + Round(pth.x), zero_y + Round(pth.y), 123);

        PointHToPointMatrix(pth, ptm);
        points.points[i]:=ptm;

        println('Bod ' + IntToStr(i) + '>' + FloatToStr(Round(points.points[i,1])) + ' ' + FloatToStr(Round(points.points[i, 2])) + ' ' + FloatToStr(Round(points.points[i, 3])) + ' | ' + FloatToStr(Round(points.points[i, 4])) + ' ');

      end;
    end;

    println('');
    for i:=1 to shape.facecount do begin
      nv:=shape.faces[i].nvector;
      println('Norml. vektor ' + IntToStr(i) + '>' + FloatToStr(nv[1]) + ' ' + FloatToStr(nv[2]) + ' ' + FloatToStr(nv[3]) + ' ');
    end;

    println('');
    println('Vntorn bod>' + FloatToStr(Round(bodv[1])) + ' ' + FloatToStr(Round(bodv[2])) + ' ' + FloatToStr(Round(bodv[3])) + ' ');
    //bod_pc(zero_x + Round(bodv[1]), zero_y + Round(bodv[2]), 3);

    {
    for i:=1 to points.pointcount do begin
      usecka_b(zero_x + Round(points.points[i, 1]), zero_y + Round(points.points[i, 2]), zero_x + Round(points.points[(i+1) mod 4, 1]), zero_y + Round(points.points[(i+1) mod 4, 2]), 1);
    end;
    }

    {
    for i:=1 to edges.edgecount do begin
      edge:=edges.edges[i];
      x1 := Round(points.points[edge[1], 1]);
      y1 := Round(points.points[edge[1], 2]);
      x2 := Round(points.points[edge[2], 1]);
      y2 := Round(points.points[edge[2], 2]);
      usecka_b(zero_x + x1, zero_y + y1, zero_x + x2, zero_y + y2, 1);
    end;
    }


    for i:=1 to shape.facecount do begin
      if (isVisibleFace(shape.faces[i], bodv, angle)) and (not chkWireframe.Checked) then begin
        println('Stena ' + IntToStr(i) + ' je viditen (uhol=' + FloatToStr(angle * (180/pi)) + ')');
        for j:=1 to shape.faces[i].ecount do begin
          edge:=shape.faces[i].edges[j];
          x1 := Round(points.points[edge[1]][1]);
          y1 := Round(points.points[edge[1]][2]);
          x2 := Round(points.points[edge[2]][1]);
          y2 := Round(points.points[edge[2]][2]);
          usecka_b(zero_x + x1, zero_y + y1, zero_x + x2, zero_y + y2, 1);
        end;
        {
        if (-pi/2 < angle) and (angle < pi/2)then
          color:=RGB(0, 0, 255 - Round((310/pi) * angle))
        else begin
          color:=clBlack
        end;
        }
        color:=RGB(0, 0, 255 - Round((310/pi) * angle));
        println('Farba: ' + IntToStr(255 - Round((310/pi) * angle)));
        //color:=clBlue;

        if abs(Round(angle * (180/pi)))<>90 then //nevykreslujeme steny, z ktorych vidno len hrany
          fillFace(shape.faces[i], Image1.Canvas, color);
        //DrawVerticesIDs(shape.faces[i]);
      end
      else begin
        println('Stena ' + IntToStr(i) + ' je skryt (uhol=' + FloatToStr(angle * (180/pi)) + ')');
        if(chkWireframe.Checked) then
          for j:=1 to shape.faces[i].ecount do begin
            edge:=shape.faces[i].edges[j];
            x1 := Round(points.points[edge[1]][1]);
            y1 := Round(points.points[edge[1]][2]);
            x2 := Round(points.points[edge[2]][1]);
            y2 := Round(points.points[edge[2]][2]);
            usecka_b(zero_x + x1, zero_y + y1, zero_x + x2, zero_y + y2, 1);
          end;
      end;
    end;
    //DrawNumbers;


    {
    for i:=1 to shape.facecount do begin
      face:=shape.faces[i];
      fillFace(face, Image1.Canvas, 1);
    end;
    }
  end;
  //usecka_b(zero_x + Round(bodp[1]), zero_y + Round(bodp[2]), zero_x + Round(bodv[1]), zero_y + Round(bodv[2]), 3);

end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Image1.Picture.Graphic.Width:=Image1.Width;
  Image1.Picture.Graphic.Height:=Image1.Height; 

end;

procedure TForm1.cmdLeftClick(Sender: TObject);
  var k:word;
begin
  k:=VK_LEFT;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.cmdRightClick(Sender: TObject);
  var k:word;
begin
  k:=VK_RIGHT;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.cmdUpClick(Sender: TObject);
  var k:word;
begin
  k:=VK_UP;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.cmdDownClick(Sender: TObject);
  var k:word;
begin
  k:=VK_DOWN;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.cmdRotZLClick(Sender: TObject);
  var k:word;
begin
  k:=VK_PRIOR;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.cmdRotZRClick(Sender: TObject);
  var k:word;
begin
  k:=VK_NEXT;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.cmdRotXLClick(Sender: TObject);
  var k:word;
begin
  k:=VK_INSERT;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.cmdRotXRClick(Sender: TObject);
  var k:word;
begin
  k:=VK_DELETE;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.cmdRotYLClick(Sender: TObject);
  var k:word;
begin
  k:=VK_HOME;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.cmdRotYRClick(Sender: TObject);
  var k:word;
begin
  k:=VK_END;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.chkDebugFillClick(Sender: TObject);
  var k:word;
begin
  grafika.debugFill := chkDebugFill.Checked;
  k:=VK_F5;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.chkUseGDIFillClick(Sender: TObject);
  var k:word;
begin
  grafika.useGDIFill := chkUseGDIFill.Checked;
  k:=VK_F5;
  FormKeyDown(Sender, k, []);
end;

procedure TForm1.chkWireframeClick(Sender: TObject);
  var k:word;
begin
  k:=VK_F5;
  FormKeyDown(Sender, k, []);

end;

procedure TForm1.cmdGoMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
    ShowMessage('Kocka' + #13#10 + '-------' + #13#10 +
      'Verzia 11. 2. 2004.' + #13#13 +
      '(C) Rbert Novotn, novotnyr@skmi.science.upjs.sk');
end;

end.

